unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    BitBtn2: TBitBtn;
    LabeledEdit2: TLabeledEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

//  Babylonian method
function sqrt_Babylonian(k: double; j: integer): double;
label
  EXT;
var
  x, bx : double;
  i: integer;
begin
  i := 0;
  if (k = 0) or (k = 1) then begin
    result := k;
    goto EXT;
  end;
  x := k;
  if k < 1 then X := 1;
  i := 0;
  repeat
    bx := x;
    x := (x + (k / x)) /2;
    inc(i);
  until (bx = x) or (i >= j);
  result := x;
EXT:
  Form1.Memo1.Lines.Append('  Loop = ' + intTostr(i));
end;

//  񕪖@
function sqrt_by_bisection(k: double; j: integer): double;
label
  EXT;
var
  def           : double;
  upper, bottom : double;
  m             : double;
  i             : integer;
begin
  i := 0;
  if (k = 0) or (k = 1) then begin
    result := k;
    goto EXT;
  end;
  upper := k;
  if k < 1 then upper := 1;
  bottom := 0;
  i := 0;
  repeat
    def := abs(upper - bottom);
    m := (bottom + upper) / 2;
//    m := bottom + (upper - bottom) / 2;
    if m * m > k then upper := m
                 else bottom := m;
    inc(i);
  until (abs(upper - bottom) = def) or (i >= j);
  result := bottom;
EXT:
  Form1.Memo1.Lines.Append('  Loop = ' + intTostr(i));
end;

//  j[g@
// X=k
// X^2 = k
// X^2-k = 0   f(X) = X^2 - K
// @@@@f'(X) = 2X
// Xn+1 = Xn-f(X)/f'(X)
// Xn+1 = Xn-(X^2-k)/(2X)
function sqrt_by_newton(k: double; j: integer): double;
label
  EXT;
var
  bx, x, next_x: double;
  i : integer;

  function f(d: double): double;
  begin
    result := d - (d * d - k) / (2 * d);
  end;

begin
  i := 0;
  if (k = 0) or (k = 1) then begin
    result := k;
    goto EXT;
  end;
  x := k;
  next_x := f(x);
  repeat
    bx := x;
    x := next_x;
    next_x := f(x);
    inc(i);
  until (x = next_x) or (bx = next_x) or (i >= j);
  result := next_x;
EXT:
  Form1.Memo1.Lines.Append('  Loop = ' + intTostr(i));
end;

// @ Babylonian method
function cubic_Babylonian(k: double; j: integer): double;
label
  EXT;
var
  ax, bx, x : double;
  i         : integer;
begin
  i := 0;
  if (k = 0) or (k = 1) then begin
    result := k;
    goto EXT;
  end;
  x := k;
  if k < 1 then x := 1;
  i := 0;
  bx := k;
  repeat
    ax := bx;
    bx := x;
    x := (x + (k / x / x)) / 2;
    inc(i);
  until (ax = x) or (bx = x) or (i >= j);
  result := x;
EXT:
  Form1.Memo1.Lines.Append('  Loop = ' + intTostr(i));
end;

// @ 񕪖@
function cubic_root_bisection(k: double; j: integer): double;
label
  EXT;
var
  def           : double;
  upper, bottom : double;
  m             : double;
  i             : integer;
begin
  i := 0;
  if (k = 0) or (k = 1) then begin
    result := k;
    goto EXT;
  end;
  upper := k;
  if k < 1 then upper := 1;
  bottom := 0;
  i := 0;
  repeat
    def := abs(upper - bottom);
    m := (bottom + upper) / 2;
//    m := bottom + (upper - bottom) / 2;
    if m * m * m > k then upper := m
                     else bottom := m;
    inc(i);
  until (abs(upper - bottom) = def) or (i >= j);
  result := bottom;
EXT:
  Form1.Memo1.Lines.Append('  Loop = ' + intTostr(i));
end;

// @j[g@
// X = K^1/3
// X^3 = K
// X^3 - K = 0    f(X) = X^3 - K
//            f'(X) = 3X^2
// Xn+1 = Xn-(X^3-k)/(3X^2)
function cubic_root_newton(k: double; j:integer): double;
label
  EXT;
var
  bx, x, next_x: double;
  i : integer;

  function f(d: double): double;
  begin
    result := d - (d * d * d - k) / (3 * d * d);
  end;

begin
  i := 0;
  if (k = 0) or (k = 1) then begin
    result := k;
    goto EXT;
  end;
  x := k;
  next_x := f(x);
  repeat
    bx := x;
    x := next_x;
    next_x := f(x);
    inc(i);
  until (x = next_x) or (bx = next_x) or (i >= j);
  result := next_x;
EXT:
  Form1.Memo1.Lines.Append('  Loop = ' + intTostr(i));
end;

// vZ
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  x, ax , sq  : double;
  ch, j       : integer;
begin
  val(labelededit1.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɌ肪܂B','',0);
    exit;
  end;
  val(labelededit2.Text, j, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɌ肪܂B','',0);
    exit;
  end;
  memo1.Clear;
  ax := abs(x);
  Memo1.Lines.Append('Babylonian method');
  sq := sqrt_Babylonian(ax, j);
  if x < 0 then
    Memo1.Lines.Append('@@x = ' + floatTostrF(sq, ffgeneral, 20, 5) + '@')
  else
    Memo1.Lines.Append('@@x = ' + floatTostrF(sq, ffgeneral, 20, 5));
  Memo1.Lines.Append('񕪖@');
  sq := sqrt_by_bisection(ax, j);
  if x < 0 then
    Memo1.Lines.Append('@@x = ' + floatTostrF(sq, ffgeneral, 20, 5) + '@')
  else
    Memo1.Lines.Append('@@x = ' + floatTostrF(sq, ffgeneral, 20, 5));
  Memo1.Lines.Append('j[g@');
  sq := sqrt_by_newton(ax, j);
  if x < 0 then
    Memo1.Lines.Append('@@x = ' + floatTostrF(sq, ffgeneral, 20, 5) + '@')
  else
    Memo1.Lines.Append('@@x = ' + floatTostrF(sq, ffgeneral, 20, 5));
  Memo1.Lines.Append('Math');
  sq := sqrt(ax);
  if x < 0 then
    Memo1.Lines.Append('@@x = ' + floatTostrF(sq, ffgeneral, 20, 5) + '@')
  else
    Memo1.Lines.Append('@@x = ' + floatTostrF(sq, ffgeneral, 20, 5));
end;

// vZ
procedure TForm1.BitBtn2Click(Sender: TObject);
var
  x, ax, cub  : double;
  ch, j       : integer;
begin
  val(labelededit1.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɌ肪܂B','',0);
    exit;
  end;
  val(labelededit2.Text, j, ch);
  if ch <> 0 then begin
    application.MessageBox('͒lɌ肪܂B','',0);
    exit;
  end;
  ax := abs(x);
  memo1.Clear;
  Memo1.Lines.Append('Babylonian method');
  cub := cubic_Babylonian(ax, j);
  if x < 0 then cub := -cub;
  Memo1.Lines.Append('@@x^1/3 = ' + floatTostrF(cub, ffgeneral, 20, 5));
  Memo1.Lines.Append('񕪖@');
  cub := cubic_root_bisection(ax, j);
  if x < 0 then cub := -cub;
  Memo1.Lines.Append('@@x^1/3 = ' + floatTostrF(cub, ffgeneral, 20, 5));
  Memo1.Lines.Append('j[g@');
  cub := cubic_root_newton(ax, j);
  if x < 0 then cub := -cub;
  Memo1.Lines.Append('@@x^1/3 = ' + floatTostrF(cub, ffgeneral, 20, 5));
  Memo1.Lines.Append('Math');
  cub := power(ax, 1 /3);
  if x < 0 then cub := -cub;
  Memo1.Lines.Append('@@x^1/3 = ' + floatTostrF(cub, ffgeneral, 20, 5));
end;

end.
